﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _689286
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            MyRadAutoCompleteBox box = new MyRadAutoCompleteBox();
            box.AutoCompleteItems.Add(new RadListDataItem("John"));
            box.AutoCompleteItems.Add(new RadListDataItem("Jim"));
            box.AutoCompleteItems.Add(new RadListDataItem("usA"));
            Controls.Add(box);
        }
    }

    public class MyRadAutoCompleteBox : RadAutoCompleteBox
    {
        protected override RadTextBoxControlElement CreateTextBoxElement()
        {
            return new MyRadAutoCompleteBoxElement();
        }

    }

    public class MyRadAutoCompleteBoxElement : RadAutoCompleteBoxElement
    {
        protected override TextBoxViewElement CreateViewElement()
        {
            return new MyAutoCompleteBoxViewElement();
        }

        protected override Type ThemeEffectiveType
        {
            get
            {
                return typeof(RadAutoCompleteBoxElement);
            }
        }
    }

    public class MyAutoCompleteBoxViewElement : AutoCompleteBoxViewElement
    {
        protected override int InsertTextBlocks(int index, string text, Type blockType)
        {
            RadAutoCompleteBoxElement element = this.Parent as RadAutoCompleteBoxElement;
            string itemText = text.TrimEnd(';');
            if (text.Contains(element.Delimiter.ToString()))
            {
                foreach (RadListDataItem item in element.AutoCompleteItems)
                {
                    if (item.Text.ToUpper() == itemText.ToUpper())
                    {
                        text = item.Text + element.Delimiter.ToString();
                        break;
                    }
                }
            }

            return base.InsertTextBlocks(index, text, blockType);
        }
    }
}
